#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # 1A.2 - 2048 - stratégie gagnante
# 
# Le jeu 2048 est assez simple et fut populaire en son temps. Comment imaginer une stratégie qui dépasser le 2048 ?

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# In[2]:


from pyquickhelper.helpgen import NbImage
NbImage("images/2048.png", width=200)


# ## Exercice 1 : implémenter les règles du jeu
# 
# Le jeu est simple : 
# 
# * Un chiffre 2 ou 4 apparaît dans une case vide d'une grille 4x4.
# * Le joueur peut choisir entre 4 directions.
# * Les chiffres de la grille sont bougés comme s'ils tombaient dans la direction souhaitée par le joueur.
# * Deux chiffres identiques consécutifs sont remplacés par leur somme.
# 
# Voir [2048](http://gabrielecirulli.github.io/2048/).

# ## Exercice 2 : implémenter une stratégie
# 
# Et mesurer ses performances.

# In[3]: